// Copyright © 2002 Elliotte Rusty Harold
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of version 2.1 of 
// the GNU Lesser General Public License as published by the 
// Free Software Foundation.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// You can contact Elliotte Rusty Harold by sending e-mail to
// elharo@metalab.unc.edu. Please include the word "XOM" in the
// subject line. The XOM home page is temporarily located at
// http://www.cafeconleche.org/XOM/  but will eventually move
// to http://www.xom.nu/

package nu.xom;

/**
 * <p>
 *  A MultipleParentException indicates an attempt to
 *  add an element that already has a parent to a node.
 * </p>
 * 
 * @author Elliotte Rusty Harold
 * @version 1.0d2
 * 
 *
 */
public class MultipleParentException extends IllegalAddException {

    /**
     * Creates a new MultipleParentException.
     */
    public MultipleParentException() {
        super();
    }

    /**
     * Creates a new MultipleParentException with a detail message.
     * 
     * @param message - indicates the specific problem
     */
    public MultipleParentException(String message) {
        super(message);
    }

    /**
     * Creates a new MultipleParentException with a detail message
     * and an underlying root cause.
     * 
     * @param message - indicates the specific problem
     * @param ex - the original cause of this exception
     */
    public MultipleParentException(String message, Throwable ex) {
        super(message, ex);
    }

}