// Copyright © 2002 Elliotte Rusty Harold
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of version 2.1 of 
// the GNU Lesser General Public License as published by the 
// Free Software Foundation.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// You can contact Elliotte Rusty Harold by sending e-mail to
// elharo@metalab.unc.edu. Please include the word "XOM" in the
// subject line. The XOM home page is temporarily located at
// http://www.cafeconleche.org/XOM/  but will eventually move
// to http://www.xom.nu/

package nu.xom;

import java.io.Writer;
import java.io.IOException;

/**
 * @author Elliotte Rusty Harold
 * @version 1.0d2
 *
 */
class UnicodeWriter extends TextWriter {

    /**
     * Constructor for UnicodeWriter.
     * @param out
     * @param encoding
     */
    UnicodeWriter(Writer out, String encoding) {
        super(out, encoding);
    }

    public void writePCDATA(char c) throws IOException {
        out.write(c);
    }

    public void writeMarkup(char c) throws IOException {
        out.write(c);   
    }

    public void writePCDATA(String s) throws IOException {
        out.write(s);
    }

    public void writeMarkup(String s) throws IOException {
        out.write(s);   
    }

    /**
     * @see nu.xom.TextWriter#needsEscaping(char)
     */
    public boolean needsEscaping(char c) {
        return false;
    }

}
