/* Copyright © 2002 Elliotte Rusty Harold
   
   This library is free software; you can redistribute it and/or
   modify it under the terms of version 2.1 of 
   the GNU Lesser General Public License as published by the 
   Free Software Foundation.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   
   You can contact Elliotte Rusty Harold by sending e-mail to
   elharo@metalab.unc.edu. Please include the word "XOM" in the
   subject line. The XOM home page is temporarily located at
   http://www.cafeconleche.org/XOM/  but will eventually move
   to http://www.xom.nu/  
*/

package nu.xom;

import javax.xml.transform.sax.SAXResult;
import org.xml.sax.ContentHandler;
import org.xml.sax.ext.LexicalHandler;

/**
 * <p>
 * This class doesn't really work yet,
 * and will probably change packages before it does.
 * Please ignore it for the time being. Thanks!
 * </p>
 * 
 * 
 * @author Elliotte Rusty Harold
 * @version 1.0d2
 *
 */
public class XOMResult extends SAXResult {

 // I could move this back into nu.xom.xslt by duplicating
 // the XOMhandler class there


  /**
   * <p>
   *  Used to determine if a 
   *  <code>TransformerFactory</code> natively supports XOM output.
   *  Factories that do not natively support XOM
   *  can use <code>XOMResult</code> objects as instances of
   *  <code>SAXResult</code> instead.
   * <p>
   */
   public final static String XOM_FEATURE = "http://nu.xom/XOMResultFeature";

    /**
     * Constructor for XOMResult.
     */
    public XOMResult() {
        super(new XOMHandler(new NodeFactory()));
        this.setLexicalHandler((LexicalHandler) this.getHandler());
    }

    public Document getDocument() {
        XOMHandler handler = (XOMHandler) this.getHandler();
        return handler.getDocument();   
    }

}
