package nu.xom.samples;

import java.util.*;
import nu.xom.Element;


public class Account {
 
  // An account is uniquely identified by account code,
  // bureau code, agency code and BEA category
  private String code;
  private String name;
  private String BEACategory;
  private String bureauCode;
  private String agencyCode;
  private String year;
  
  private List   subfunctions = new ArrayList();
  
  private static Map instances = new HashMap();

  // Use a private constructor so clients 
  // have to use the factory method
  private Account(String name, String code, String BEACategory, 
   String bureauCode, String agencyCode, String year) {
        
    this.name = name;
    this.code = code;
    this.BEACategory = BEACategory;
    this.bureauCode = bureauCode;
    this.agencyCode = agencyCode;
    this.year = year;
    
  }
  
  public static Account getInstance(String name, String code, 
   String BEACategory, String bureauCode, String agencyCode, 
   String year) {
        
    String key = code + " " + BEACategory + " " + bureauCode 
     + " " + agencyCode + " " + year;
    Account account = (Account) instances.get(key);
    if (account == null) {
      account = new Account(name, code, BEACategory, bureauCode, 
       agencyCode, year);
      instances.put(key, account);
    }
    
    return account;
        
  }
  
  public void add(Subfunction sfx) {
    if (!subfunctions.contains(sfx)) subfunctions.add(sfx);     
  }
  
  public Element getXML() {
        
    Element account = new Element("Account");
    Element name = new Element("Name");
    Element code = new Element("Code");
    Element BEACategory = new Element("BEACategory");
    name.appendChild(this.name);
    code.appendChild(this.code);
    BEACategory.appendChild(this.BEACategory);
    account.appendChild(name);
    account.appendChild(code);
    account.appendChild(BEACategory);

    Iterator iterator = subfunctions.iterator();
    while (iterator.hasNext()) {
      Subfunction subfunction = (Subfunction) iterator.next();
      account.appendChild(subfunction.getXML());
    }
    return account;
    
  }
           
}
