package nu.xom.samples;

import javax.xml.parsers.*;
import nu.xom.Document;
import nu.xom.Element;
import nu.xom.Elements;
import nu.xom.Builder;
import nu.xom.ParseException;
import java.io.*;

// Need to test this????
public class ExampleExtractor {

	private static int chapter = 0;
  
    public static void extract(Element element) 
      throws IOException {		

        Elements elements = element.getChildElements();
    	for (int i = 0; i < elements.size(); i++) {
			Element child = elements.get(i);
			if (child.getQualifiedName().equals("chapter")) {
				chapter++;
			}       
 			if (child.getQualifiedName().equals("example")) {
				extractExample(child, chapter);
			}
			else {
				extract(child);	
			}  
	    } // end chapters loop

  }

	private static void extractExample(Element example, int chapter) 
	  throws IOException {

        String fileName = example.getAttribute("id").getValue();
        Element programlisting = example.getFirstChildElement("programlisting");
        
        // A few examples use screens instead of programlistings
        if (programlisting == null) programlisting = example.getFirstChildElement("screen");
        // If it's still null, skip it
        if (programlisting == null) return;
        String code = programlisting.getValue();
        
        // write code into a file
        File dir = new File("examples2/" + chapter);
        dir.mkdirs();
        File file = new File(dir, fileName);
        System.out.println(file);
        FileOutputStream fout = new FileOutputStream(file);
        Writer out = new OutputStreamWriter(fout, "UTF-8");
        // Buffering almost always helps performance a lot
        out = new BufferedWriter(out);
        out.write(code);
        // Be sure to flush and close your streams
        out.flush();
        out.close();
	
	}
  
  	public static void main(String[] args) {

	    if (args.length <= 0) {
	      System.out.println("Usage: java ExampleExtractor URL");
	      return;
	    }
	    String url = args[0];
	    
	    try {
	        Builder builder = new Builder(true);
	        // Read the document
	        Document document = builder.build(args[0]);
	     
	     	// Extract the examples
	     	extract(document.getRootElement());
	
	    }
	    catch (ParseException e) {
	        System.out.println(e);
	    }
	    catch (IOException e) { 
	      	System.out.println(
	          "Due to an IOException, the parser could not read " + url
	        ); 
	        System.out.println(e);
	    } 
     
    } // end main
  
}
  
