package nu.xom.samples;

import nu.xom.Document;
import nu.xom.Element;
import nu.xom.Elements;
import nu.xom.Builder;
import nu.xom.ParseException;
import java.io.IOException;


public class ExampleLister {

	private static int chapter = 0;

    public static void list(Element root) {

		chapter = 0;
		// Does this call for an isA method in Element?
		// i.e. is such and such in tcertain namespace?
		// or is it better to do this as part of a generic traversal
		// API???? or a utility class
		if (root.getLocalName().equals("chapter")) {
			chapter++;
			exampleNumber = 0;
			list(root);	
		} 
		else {
        	Elements elements = root.getChildElements();
    		for (int i = 0; i < elements.size(); i++) {
				Element child = elements.get(i);
				if (child.getLocalName().equals("chapter")) {
					chapter++;
                    exampleNumber = 0;
					findExamples(child);	
				}
				else {
					list(child);	
				}
    		}
			
		}   	
    	
    }		

  	private static int exampleNumber = 0;
  
    private static void findExamples(Element element) {		

        Elements elements = element.getChildElements();
    	for (int i = 0; i < elements.size(); i++) {
			Element child = elements.get(i);
 			if (child.getQualifiedName().equals("example")) {
				printExample(child);
			}
			else {
				findExamples(child);	
			}  
	    } 

  }

	private static void printExample(Element example) {

		exampleNumber++;
        Element title = example.getFirstChildElement("title");
        
        String caption = "Example " + chapter + "." + exampleNumber
         + ": " + title.getValue();
        
       System.out.println(caption);
	
	}
  
  	public static void main(String[] args) {

	    if (args.length <= 0) {
	      System.out.println("Usage: java ExampleLister URL");
	      return;
	    }
	    String url = args[0];
	    
	    try {
	        Builder builder = new Builder();
//	        Builder builder = new Builder(true);
	        // Read the document
	        Document document = builder.build(args[0]);
	     
	     	// List the examples
	     	list(document.getRootElement());
	
	    }
	    catch (ParseException e) {
	        System.out.println(e);
	    }
	    catch (IOException e) { 
	      	System.out.println(
	          "Due to an IOException, the parser could not read " + url
	        ); 
	        System.out.println(e);
	    } 
     
    } // end main
  
}