package nu.xom.samples;

import java.net.*;
import java.io.*;
import nu.xom.*;

// Needs to be tested
public class FibonacciSOAPClient {
  
  public final static String defaultServer 
   = "http://www.elharo.com/fibonacci/XML-RPC";
  public final static String SOAP_ACTION 
   = "http://www.example.com/fibonacci";
      
  public static void main(String[] args) {

    if (args.length == 0) {
      System.out.println(
       "Usage: java FibonacciSOAPClient index serverURL"); 
      return;
    }
    
    String index = args[0];
    
    String server;
    if (args.length <= 1) server = defaultServer;
    else server = args[1];
    
    try {
        URL u = new URL(server);
        URLConnection uc = u.openConnection();
        HttpURLConnection connection = (HttpURLConnection) uc;
        connection.setDoOutput(true);
        connection.setDoInput(true); 
        connection.setRequestMethod("POST");
     	connection.setRequestProperty("SOAPAction", SOAP_ACTION);
     
        OutputStream out = connection.getOutputStream();
      
        String SOAPNamespace = "http://www.w3.org/2001/XMLSchema-instance";
        Element envelope = new Element("SOAP-ENV:Envelope",
		 SOAPNamespace);
		Element body = new Element("SOAP-ENV:Body",
		 SOAPNamespace);
		Element calculateFibonacci = new Element("calculateFibonacci",
		 "http://namespaces.cafeconleche.org/xmljava/ch3/");
		calculateFibonacci.appendChild(index);
		calculateFibonacci.addNamespaceDeclaration("xsi", 
		 "http://www.w3.org/2001/XMLSchema-instance");
		Attribute type = new Attribute("type", "xsi:positiveInteger");
		calculateFibonacci.add(type);
		
		envelope.appendChild(body);
		body.appendChild(calculateFibonacci);

      	Document doc = new Document(envelope);

		Serializer serializer = new Serializer(out, "US-ASCII");
      	serializer.write(doc);
      	
      	InputStream in = connection.getInputStream();
      	
      	Builder parser = new Builder();
      	Document response = parser.build(in);

      	in.close();
      	out.close();
      	connection.disconnect();

		/* This is the response we expect:
		 * <?xml version="1.0"?>
<SOAP-ENV:Envelope
 xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" />
  <SOAP-ENV:Body>
    <Fibonacci_Numbers 
      xmlns="http://namespaces.cafeconleche.org/xmljava/ch3/">
      <fibonacci index="1">1</fibonacci>
      <fibonacci index="2">1</fibonacci>
      <fibonacci index="3">2</fibonacci>
      <fibonacci index="4">3</fibonacci>
      <fibonacci index="5">5</fibonacci>
      <fibonacci index="6">8</fibonacci>
      <fibonacci index="7">13</fibonacci>
      <fibonacci index="8">21</fibonacci>
      <fibonacci index="9">34</fibonacci>
      <fibonacci index="10">55</fibonacci>
    </Fibonacci_Numbers>
  </SOAP-ENV:Body>
</SOAP-ENV:Envelope>
		 * 
		 */

      	Element responseEnvelope = response.getRootElement();      	
      	Element responseBody = responseEnvelope.getFirstChildElement("Body", 
      	 "http://schemas.xmlsoap.org/soap/envelope/");
      	Element responseNumbers = responseEnvelope.getFirstChildElement(
      	 "Fibonacci_Numbers");
      	Elements results = responseNumbers.getChildElements("fibonacci", 
      	 "http://namespaces.cafeconleche.org/xmljava/ch3/");
		for (int i = 0; i < results.size(); i++) {
		    System.out.println(results.get(i).getValue());	
		}
      	// Need to handle faults????
      
      	
    }
    catch (ParseException ex) {
      System.err.println("Server sent malformed output"); 
      System.err.println(ex); 
    }
    catch (NullPointerException ex) {
      System.err.println("Server sent invalid output without the expected content."); 
      System.err.println(ex); 
    }
    catch (IOException e) {
      System.err.println(e); 
      e.printStackTrace();
    }
  
  }  // end main

}