package nu.xom.samples;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.math.BigInteger;
import nu.xom.*;


public class FibonacciServlet extends HttpServlet {

    public void doGet(
      HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
    
    	//read the query string
    	int numberOfGenerations = 10;
    	String generations = request.getParameter("generations");
    	try {
        	numberOfGenerations = Integer.parseInt(generations);
    	}
    	catch (Exception e) { // NumberFormat or NullPointerException
      		// use default value of 10 
    	}
     
     	response.setContentType("text/xml; charset=UTF-8");               
        OutputStream out = response.getOutputStream();
    
        Element root = new Element("Fibonacci_Numbers"); 
        Document doc = new Document(root);
	    ProcessingInstruction stylesheet = new 
	      ProcessingInstruction("xml-stylesheet", 
	      "type='text/css' href='/xml/styles/fibonacci.css'");
        doc.insertChild(0, stylesheet);
    
        BigInteger low  = BigInteger.ONE;
        BigInteger high = BigInteger.ONE;      
        for (int i = 1; i <= numberOfGenerations; i++) {
    	    Element fibonacci = new Element("fibonacci");
    	    Attribute index = new Attribute("index", String.valueOf(i));
    	    fibonacci.add(index);
	        fibonacci.appendChild(low.toString());
       
            BigInteger temp = high;
	        high = high.add(low);
     	    low = temp;
        }
        Serializer serializer = new Serializer(out, "UTF-8");
        serializer.write(doc);
        serializer.flush();
	 	out.close();
    
  }

  // In ch05.html in book, Fibonacci XML-RPC servlet *not*
  // introduced in chapter 3.????

	public void doPost(
	  HttpServletRequest request, HttpServletResponse response)
	  throws ServletException, IOException {
    	doGet(request, response);
  	}

}