package nu.xom.samples;

/**
 * @author Elliotte Rusty Harold
 *
 */
import nu.xom.*;
import java.io.IOException;


public class Linkset {
  
  public static void main(String[] args) {
    
    String url = "http://www.slashdot.org/slashdot.rdf";
    
    try {
      Builder parser = new Builder();
      
      // Parse the document
      Document document = parser.build(url); 
      Element oldRoot = document.getRootElement();
      Element newRoot = new Element("linkset");
      Elements toplevel = oldRoot.getChildElements();
      for (int i = 0; i < toplevel.size(); i++) {
        Element element = toplevel.get(i); 
        Element link = element.getFirstChildElement("link", "http://my.netscape.com/rdf/simple/0.9/");
        link.detach();
        newRoot.appendChild(link);
      }
      System.out.println(newRoot.getStringForm());
    }
    catch (ParseException e) {
      System.out.println(url + " is not well-formed.");
    }
    catch (IOException e) { 
      System.out.println(
       "Due to an IOException, the parser could not read " + url
      ); 
    }
     
  } // end main

}

