package nu.xom.samples;

import nu.xom.Element;
import nu.xom.Document;
import nu.xom.Attribute;
import nu.xom.DocType;
import nu.xom.Serializer;
import java.io.IOException;
import java.math.BigInteger;

/**
 * @author Elliotte Rusty Harold
 *
 */
public class PrettyFibonacci {

    public static void main(String[] args) {
   
        BigInteger low  = BigInteger.ONE;
        BigInteger high = BigInteger.ONE;      

/* <mathml:math xmlns:mathml="http://www.w3.org/1998/Math/MathML">
  <mathml:mrow>
    <mathml:mi>f(1)</mathml:mi>
    <mathml:mo>=</mathml:mo>
    <mathml:mn>1</mathml:mn>
  </mathml:mrow> */
      String namespace = "http://www.w3.org/1998/Math/MathML";
      Element root = new Element("mathml:math", namespace);  
      for (int i = 1; i <= 10; i++) {
        Element mrow = new Element("mathml:mrow", namespace);
        Element mi = new Element("mathml:mi", namespace);
        Element mo = new Element("mathml:mo", namespace);
        Element mn = new Element("mathml:mn", namespace);
        mrow.appendChild(mi);
        mrow.appendChild(mo);
        mrow.appendChild(mn);
        root.appendChild(mrow);
        mi.appendChild("f(" + i + ")");
        mo.appendChild("=");
        mn.appendChild(low.toString());
        
        BigInteger temp = high;
        high = high.add(low);
        low = temp;
      }
      Document doc = new Document(root);
      
      Serializer serializer = new Serializer(System.out);
      serializer.setIndent(4);
      serializer.setMaxLength(64);
      try {
          serializer.write(doc);  
      }
      catch (IOException ex) {
        System.err.println(ex); 
      }  
    }

}