package nu.xom.samples;

import java.io.IOException;
import nu.xom.Builder;
import nu.xom.Document;
import nu.xom.ProcessingInstruction;
import nu.xom.TreeNode;
import nu.xom.ParseException;


/**
 * @author Elliotte Rusty Harold
 *
 */
public class ProcessingInstructionLister {

    public static void list(TreeNode node) {
        
        for (int i = 0; i < node.getChildCount(); i++) {           
            TreeNode child = node.getChild(i);
            if (child instanceof ProcessingInstruction) {
                System.out.println(child.getStringForm());
            }
            else {
                list(child);   
            }
        }
        
    } 

    public static void main(String[] args) {
  
        if (args.length <= 0) {
          System.out.println("Usage: java ProcessingInstructionLister URL");
          return;
        }
        
        try {
          Builder parser = new Builder();
          Document doc = parser.build(args[0]);
          list(doc);
        }
        catch (ParseException ex) {
          System.out.println(args[0] + " is not well-formed.");
          System.out.println(ex.getMessage());
        }
        catch (IOException ex) { 
          System.out.println(
           "Due to an IOException, the parser could not check " 
           + args[0]
          ); 
        }
  
    }

}