package nu.xom.samples;

/**
 * @author Elliotte Rusty Harold
 *
 */
import nu.xom.ProcessingInstruction;
import nu.xom.Attribute;
import nu.xom.Builder;
import nu.xom.Element;
import nu.xom.Document;
import nu.xom.Attributes;
import nu.xom.ParseException;
import java.io.*;


public class PseudoAttributes {

    public static Attributes getAttributes(ProcessingInstruction pi)
      throws ParseException  {
  
        StringBuffer sb = new StringBuffer("<");
        sb.append(pi.getTarget());
        sb.append(" ");
        sb.append(pi.getValue());
        sb.append("/>");
        
        try {
            InputStream in = new ByteArrayInputStream(sb.toString().getBytes("UTF-8"));
            Builder parser = new Builder();
              
            // This line will throw a ParseException if the processing
            // instruction does not use pseudo-attributes
            Document doc = parser.build(in);
            Element root = doc.getRootElement();
            Attributes pseudo = root.getAttributes();
            return pseudo;
        }
        catch (Exception ex) {
            throw new ParseException(pi.getStringForm() 
             + " is not in pseudo-attribute format.", ex);   
        }
    
    }
  
}
