package nu.xom.samples;

import java.io.IOException;
import nu.xom.Builder;
import nu.xom.ParseException;
import nu.xom.ValidityException;
import org.xml.sax.XMLReader;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.XMLReaderFactory;

/**
 * Stiill need to see if I can distinguish
 * DTD and schema validation
 * 
 * 
 * @author Elliotte Rusty Harold
 *
 */
public class SchemaValidator {

  public static void main(String[] args) {
  
    if (args.length <= 0) {
      System.out.println("Usage: java SchemaValidator URL");
      return;
    }
    
    try {      
      XMLReader xerces = XMLReaderFactory.createXMLReader(
       "org.apache.xerces.parsers.SAXParser"); 
      xerces.setFeature("http://apache.org/xml/features/validation/schema", true);                         

      Builder parser = new Builder(xerces, true);
      parser.build(args[0]);
      System.out.println(args[0] + " is schema valid.");
    }
    catch (SAXException ex) {
      System.out.println("Could not load Xerces.");
      System.out.println(ex.getMessage());
      // add line and column numbers????
    }
    catch (ParseException ex) {
      System.out.println(args[0] + " is not schema valid.");
      System.out.println(ex.getMessage());
      ex.printStackTrace();
      // add line and column numbers ????
    }
    catch (IOException ex) { 
      System.out.println(
       "Due to an IOException, Xerces could not check " 
       + args[0]
      ); 
      ex.printStackTrace();
    }
  
  }

}