package nu.xom.samples;

/**
 * @author Elliotte Rusty Harold
 *
 */
import java.io.IOException;
import nu.xom.Document;
import nu.xom.Text;
import nu.xom.ProcessingInstruction;
import nu.xom.Element;
import nu.xom.DocType;
import nu.xom.Comment;
import nu.xom.XMLException;

public class SimpleSVG {

  public static void main(String[] args) {
     
    try {
      // Find the implementation
      
      // Create the document
      DocType svgDOCTYPE = new DocType(
       "svg", "-//W3C//DTD SVG 1.0//EN", 
       "http://www.w3.org/TR/2001/REC-SVG-20010904/DTD/svg10.dtd"
      );
      
       
      // Fill the document
      Element root = new Element("svg", 
        "http://www.w3.org/2000/svg");
      Document doc = new Document(root);
      doc.insertChild(0, svgDOCTYPE);
      ProcessingInstruction xmlstylesheet = new ProcessingInstruction("xml-stylesheet",
       "type=\"text/css\" href=\"standard.css\"");
      doc.insertChild(0, xmlstylesheet);
      Comment comment = new Comment(
       "An example from Chapter 10 of Processing XML with Java");
      doc.insertBefore(root, comment);
      Element desc = new Element("desc", "http://www.w3.org/2000/svg");
      root.appendChild(desc);
      Text descText = new Text("An example from Processing XML with Java");
      desc.appendChild(descText);
      
      // Serialize the document onto System.out
      System.out.println(doc.getStringForm());
        
    }
    catch (XMLException e) {
      System.err.println(e); 
    }
  
  }

}

