package nu.xom.samples;

import java.io.IOException;
import nu.xom.Builder;
import nu.xom.Document;
import nu.xom.ParseException;

/**
 * A program that walks the tree, extracting all the PCDATA
 * and printing it on System.out
 * 
 * @author Elliotte Rusty Harold
 *
 */
public class TextExtractor {

	public static void main(String[] args) {
	  
	    if (args.length <= 0) {
	      System.out.println("Usage: java TextExtractor URL");
	      return;
	    }
	    
	    try {
	        Builder parser = new Builder();
	        Document doc = parser.build(args[0]);
			System.out.println(doc.getValue());
	
	    }
	    catch (ParseException ex) {
	      System.out.println(args[0] + " is not well-formed.");
	      System.out.println(ex.getMessage());
	      // add line and column numbers to parse exception????
	    }
	    catch (IOException ex) { 
	      System.out.println(
	       "Due to an IOException, the parser could not check " 
	       + args[0]
	      ); 
	    }
	  
	}

}
