package nu.xom.samples;

/**
 * @author Elliotte Rusty Harold
 *
 */
import java.io.IOException;
import nu.xom.Builder;
import nu.xom.TreeNode;
import nu.xom.ParseException;


public class TreeReporter {

    public static void main(String[] args) {
     
        if (args.length <= 0) {
          System.out.println("Usage: java TreeReporter URL");
          return; 
        }
         
        TreeReporter iterator = new TreeReporter();
        try {
          Builder parser = new Builder();
          
          // Read the entire document into memory
          TreeNode document = parser.build(args[0]); 
          
          // Process it starting at the root
          iterator.followNode(document);
    
        }
        catch (IOException e) { 
          System.out.println(e); 
        }
        catch (ParseException e) { 
          System.out.println(e); 
        }
  
    } // end main

    private PropertyPrinter printer = new PropertyPrinter();
  
  // note use of recursion
    public void followNode(TreeNode node) throws IOException {
    
        printer.writeNode(node);
        TreeNode firstChild = node.getFirstChild();
        if (firstChild != null) followNode(firstChild);
        TreeNode nextNode = node.getNextSibling();
        if (nextNode != null) followNode(nextNode);
    
  }

}