package nu.xom.samples;

import java.io.IOException;
import nu.xom.Builder;
import nu.xom.ParseException;
import nu.xom.ValidityException;

/**
 * @author Elliotte Rusty Harold
 *
 */
public class Validator {

  public static void main(String[] args) {
  
    if (args.length <= 0) {
      System.out.println("Usage: java Validator URL");
      return;
    }
    
    try {
      Builder parser = new Builder(true);
      parser.build(args[0]);
      System.out.println(args[0] + " is valid.");
    }
    catch (ValidityException ex) {
      System.out.println(args[0] + " is not valid.");
      System.out.println(ex.getMessage());
      // add line and column numbers????
    }
    catch (ParseException ex) {
      System.out.println(args[0] + " is not well-formed.");
      System.out.println(ex.getMessage());
      ex.printStackTrace();
      // add line and column numbers ????
    }
    catch (IOException ex) { 
      System.out.println(
       "Due to an IOException, the parser could not check " 
       + args[0]
      ); 
    }
  
  }

}